'=========================================================================
' File Parser / fecther / Reader (v1.0)
'=========================================================================
'
'
'
' Used to retrive information, through variables, 
' from any web page or text ouput file (http, php, asp, txt, etc...)
'
'                               -  Neekun  (lacuna_loser@hotmail.com)
'
'------------------------------------------------------------------------
'
' This is a customized version of the Internet Script template
' created by mnorth and mb_voip (v1.3) used to download information 
' from HTTP pages.
'
' Used to retrive information from HTTP pages.  Through variables

'=========================================================================
' VARIABLES :
'=========================================================================

' TMP_FILE: The name of the temp file you want to use for the script
'       (needed For the GetInfoTempFile() function only)
' SITE_URL: The url of the site you want to get your data from
' PAGE_CHECK: A string in the HTML source to verify that you have got the
'       right page (eg. use the page title)
' FIRST_CHECK: String to mark the start of the entire text area to be
'       examined
' END_CHECK: String marking the end of the entire section to be searched
' FIRST_CHECK2: String marking the start of the item(s) you wish to return
' END_CHECK2: String marking the end of the item(s) you wish to return
' REMOVE_END_CHECK: This will remove the END_CHECK string from the found
'       string so it will not be found again.  This could cause infinite
'       loops if you are not careful. Default is note to remove the
'       END_CHECK string.  This is useful when you have the FIRST_CHECK2
'       value the same as the END_CHECK2
' USERNAME: String used to pass to the web site as the username signin
' PASSWORD: String used to pass the users password to the site.  This is
'       not using SSL so its up to the user to determine their risk factor
' HTTP_METHOD: Method to access the HTTP page.  Either GET or POST
' BULLET_ON_NEW_LINES: This is the characters you wish to precede each new
'       item found within the HTML. You can put any # of characters, or
'       none to leave them blank.
' SEPERATOR: This variable allows the user to determine what they want
'       in-between two found strings. &vbCrLf;, ",", any string data is
'       allowed and if it is left blank, nothing will be added.
' REMOVE_NEWLINES: This will override all CRLF formatting and remove them
'       from the output all together. Valid values are yes or anything else
'
'
'                      > view readme for more details
'
'
'=========================================================================


'The same as GetInfo accept it is hardcoded for those that do not want to use Parameters.
Function HardCoded_GetInfo()
	SITE_URL	= "http://www.packet8.net/support/faqs/"
	PAGE_CHECK 	= "<title>Packet8: Support</title>"
	FIRST_CHECK	= "Service Status</span>"
	END_CHECK	= "<form method=post action"
	FIRST_CHECK2	= "<br><br>"
	END_CHECK2	= "<br><br>"
	REMOVE_END_CHECK= "no"
	USERNAME	= ""
	PASSWORD	= ""
	HTTP_METHOD	= "Get"
	BULLET_ON_NEW_LINES = "- "
	SEPERATOR	= vbCrLf & vbCrLf
	REMOVE_NEWLINES	= "No"

	
        HardCoded_GetInfo = GetInfo(SITE_URL, PAGE_CHECK, FIRST_CHECK, END_CHECK, FIRST_CHECK2, END_CHECK2, REMOVE_END_CHECK, USERNAME, PASSWORD, HTTP_METHOD, BULLET_ON_NEW_LINES, SEPERATOR, REMOVE_NEWLINES)


End Function



' Returns the required items from the HTML string
Function GetInfo(SITE_URL, PAGE_CHECK, FIRST_CHECK, END_CHECK, FIRST_CHECK2, END_CHECK2, REMOVE_END_CHECK, USERNAME, PASSWORD, HTTP_METHOD, BULLET_ON_NEW_LINES, SEPERATOR, REMOVE_NEWLINES)

        Dim htmlResult, output, newsItem, mainFeature
        htmlResult = ReturnHTML(SITE_URL, USERNAME, PASSWORD, HTTP_METHOD)
        output = Null

        GetInfo = htmlResult

        startpos = InStr(htmlResult, PAGE_CHECK)

        If startpos > 0 Then
                
                'Selects on the string to search in
                startpos = InStr(startpos, htmlResult, FIRST_CHECK) + Len(FIRST_CHECK)
                endPos = InStr(startpos, htmlResult, END_CHECK) - startpos
                htmlResult = Mid(htmlResult, startpos, endPos)
                
                startpos = 1
                Do While InStr(startpos, htmlResult, FIRST_CHECK2) > 0

                        posOne = InStr(startpos, htmlResult, FIRST_CHECK2) + Len(FIRST_CHECK2)
                        posTwo = InStr(posOne + 1, htmlResult, END_CHECK2)

                        If posOne > 0 And posTwo > posOne Then

                                'grab the name of the news item
                                newsItem = Right(Mid(htmlResult, posOne, posTwo - posOne), posTwo - posOne)
                                newsItem = Trim(Replace(newsItem, vbCrLf, ""))
                  

                                ' new start position
                                If UCase(REMOVE_END_CHECK) = "YES" Then
                                    startpos = posTwo + Len(END_CHECK2)
                                Else
                                    startpos = posTwo
                                End If
                                
                                'append the user to the list and put a newline char after it
                                output = output & Bullet_On_new_lines & newsItem & SEPERATOR
                        Else
                            Exit Do
                        End If

                Loop

        Else
                output = "Could not obtain data."
        End If

        GetInfo = TrimHTML(output)
        GetInfo = ReplaceHTML(GetInfo)

        If UCase(REMOVE_NEWLINES) = "YES" Then
                GetInfo = Replace(GetInfo, vbCr, " ")
                GetInfo = Replace(GetInfo, vbLf, " ")
                GetInfo = Replace(GetInfo, vbCrLf, " ")
        End If

        GetInfo = Trim(GetInfo)

End Function


' Puts the HTML string in TMP_FILE in samurize directory
Function GetInfoTempFile(TMP_FILE, SITE_URL, PAGE_CHECK, FIRST_CHECK, END_CHECK, FIRST_CHECK2, END_CHECK2, REMOVE_END_CHECK, USERNAME, PASSWORD, HTTP_METHOD, BULLET_ON_NEW_LINES, SEPERATOR, REMOVE_NEWLINES)

        Set fs = CreateObject("Scripting.FileSystemObject")
        Set f = fs.CreateTextFile(TMP_FILE & ".tmp", True)

        http_data = GetInfo(SITE_URL, PAGE_CHECK, FIRST_CHECK, END_CHECK, FIRST_CHECK2, END_CHECK2, REMOVE_END_CHECK, USERNAME, PASSWORD, HTTP_METHOD, BULLET_ON_NEW_LINES, SEPERATOR, REMOVE_NEWLINES)

        f.Write (http_data)
        f.Close
        Set f = Nothing
        Set fs = Nothing

        GetInfoTempFile = Trim(http_data)
End Function



' Gets the HTML string from the web page
Private Function ReturnHTML(sURL, USERNAME, PASSWORD, HTTP_METHOD)
        Dim ADODBStream, objXMLHTTP
        Set ADODBStream = CreateObject("ADODB.Stream")
        Set objXMLHTTP = CreateObject("MSXML2.ServerXMLHTTP")

        If UCase(HTTP_METHOD) = "POST" Then
                objXMLHTTP.Open "POST", sURL, False
                objXMLHTTP.Send "USERNAME=" + USERNAME + "&PASSWORD=" + PASSWORD
        Else
                objXMLHTTP.Open "GET", sURL, False, USERNAME, PASSWORD
                objXMLHTTP.Send
        End If
        
        
        'Outputs Binary Stream
        ADODBStream.Type = 1
        ADODBStream.Open
        ADODBStream.Write objXMLHTTP.responsebody
        ADODBStream.SaveToFile "StrHTML.tmp", 2
        ADODBStream.Type = 1
        ADODBStream.Close

        'INPUTS TEXT STREAM
        ADODBStream.Type = 2
        ADODBStream.Charset = "iso-8859-1"
        ADODBStream.Open
        ADODBStream.LoadFromFile "StrHTML.tmp"
        ReadTextFile = ADODBStream.ReadText
        ADODBStream.Close

        ReturnHTML = ReadTextFile

        Set objXMLHTTP = Nothing
        Set ADODBStream = Nothing
End Function


'very simple function that will remove all html tags
'(posted by Alderaic)
'---------------------------------------------------
Private Function TrimHTML(str)
pos_deb = InStr(1, str, "<")
Do Until pos_deb = 0
    pos_fin = InStr(pos_deb, str, ">")
    part_d = Mid(str, 1, pos_deb - 1)
    part_f = Mid(str, pos_fin + 1, Len(str) - pos_fin)
    str = part_d & part_f
    pos_deb = InStr(1, str, "<")
Loop
TrimHTML = str
End Function


'ReplaceHTML (posted by Goodspeed)
'---------------------------------
Private Function ReplaceHTML(str)

 str = Replace(str, "&nbsp;", " ")
 str = Replace(str, "&auml;", "")
 str = Replace(str, "&uuml;", "")
 str = Replace(str, "&ouml;", "")
 str = Replace(str, "&Auml;", "")
 str = Replace(str, "&Uuml;", "")
 str = Replace(str, "&Ouml;", "")
 str = Replace(str, "&szlig;", "")
 str = Replace(str, "&quot;", """")
 str = Replace(str, "&euro;", "")
 str = Replace(str, "&pound;", "")
 str = Replace(str, "&yen;", "")
 str = Replace(str, "&amp;", "&")
 str = Replace(str, "&lt;", "<")
 str = Replace(str, "&gt;", ">")
 str = Replace(str, "&iexcl;", "")
 str = Replace(str, "&cent;", "")
 str = Replace(str, "&curren;", "")
 str = Replace(str, "&brvbar;", "")
 str = Replace(str, "&sect;", "")
 str = Replace(str, "&uml;", "")
 str = Replace(str, "&copy;", "")
 str = Replace(str, "&ordf;", "")
 str = Replace(str, "&laquo;", "")
 str = Replace(str, "&not;", "")
 str = Replace(str, "&shy;", "")
 str = Replace(str, "&reg;", "")
 str = Replace(str, "&macr;", "")
 str = Replace(str, "&deg;", "")
 str = Replace(str, "&plusmn;", "")
 str = Replace(str, "&sup2;", "")
 str = Replace(str, "&sup3;", "")
 str = Replace(str, "&acute;", "")
 str = Replace(str, "&micro;", "")
 str = Replace(str, "&para;", "")
 str = Replace(str, "&middot;", "")
 str = Replace(str, "&cedil;", "")
 str = Replace(str, "&sup1;", "")
 str = Replace(str, "&ordm;", "")
 str = Replace(str, "&raquo;", "")
 str = Replace(str, "&frac14;", "")
 str = Replace(str, "&frac12;", "")
 str = Replace(str, "&frac34;", "")
 str = Replace(str, "&iquest;", "")
 str = Replace(str, "&Agrave;", "")
 str = Replace(str, "&Aacute;", "")
 str = Replace(str, "&Acirc;", "")
 str = Replace(str, "&Atilde;", "")
 str = Replace(str, "&Aring;", "")
 str = Replace(str, "&AElig;", "")
 str = Replace(str, "&Ccedil;", "")
 str = Replace(str, "&Egrave;", "")
 str = Replace(str, "&Eacute;", "")
 str = Replace(str, "&Ecirc;", "")
 str = Replace(str, "&Euml;", "")
 str = Replace(str, "&Igrave;", "")
 str = Replace(str, "&Iacute;", "")
 str = Replace(str, "&Icirc;", "")
 str = Replace(str, "&Iuml;", "")
 str = Replace(str, "&ETH;", "")
 str = Replace(str, "&Ntilde;", "")
 str = Replace(str, "&Ograve;", "")
 str = Replace(str, "&Oacute;", "")
 str = Replace(str, "&Ocirc;", "")
 str = Replace(str, "&Otilde;", "")
 str = Replace(str, "&times;", "")
 str = Replace(str, "&Oslash;", "")
 str = Replace(str, "&Ugrave;", "")
 str = Replace(str, "&Uacute;", "")
 str = Replace(str, "&Ucirc;", "")
 str = Replace(str, "&Yacute;", "")
 str = Replace(str, "&THORN;", "")
 str = Replace(str, "&agrave;", "")
 str = Replace(str, "&aacute;", "")
 str = Replace(str, "&acirc;", "")
 str = Replace(str, "&atilde;", "")
 str = Replace(str, "&aring;", "")
 str = Replace(str, "&aelig;", "")
 str = Replace(str, "&ccedil;", "")
 str = Replace(str, "&egrave;", "")
 str = Replace(str, "&eacute;", "")
 str = Replace(str, "&ecirc;", "")
 str = Replace(str, "&euml;", "")
 str = Replace(str, "&igrave;", "")
 str = Replace(str, "&iacute;", "")
 str = Replace(str, "&icirc;", "")
 str = Replace(str, "&iuml;", "")
 str = Replace(str, "&eth;", "")
 str = Replace(str, "&ntilde;", "")
 str = Replace(str, "&ograve;", "")
 str = Replace(str, "&oacute;", "")
 str = Replace(str, "&ocirc;", "")
 str = Replace(str, "&divide;", "")
 str = Replace(str, "&oslash;", "")
 str = Replace(str, "&ugrave;", "")
 str = Replace(str, "&uacute;", "")
 str = Replace(str, "&ucirc;", "")
 str = Replace(str, "&yacute;", "")
 str = Replace(str, "&thorn;", "")
 str = Replace(str, "&yuml;", "")
 str = Replace(str, "&vbCrLf;", vbCrLf)
 
 ReplaceHTML = str
 
End Function

